/*
 * client.h
 * Copyright (C) 1999 Patrick Alken
 *
 * $Id: client.h,v 1.00 1999/08/21 13:57:38 wnder Exp $
 */

/*
 * Prototypes
 */

void UpdateUserModes(Luser *lptr, char *modes);
Luser *AddClient(char **av);
void DeleteClient(Luser *lptr);
char *GetNick(char *nickname);
int IsRegistered(Luser *lptr, int sockfd);
int IsOperator(Luser *lptr);
int IsValidAdmin(Luser *lptr);
int IsNickCollide(Luser *servptr, char **av);

struct u_chan
{
	struct u_chan *next;
	int flags; /* channel flags - opped/voiced etc */
	Channel *chptr; /* pointer to channel */
};

/* User structure */
struct LuserInfo

{
	struct LuserInfo *next, *prev, *hnext, *cnext;

#ifdef BLOCK_ALLOCATION

	/*
	 * When BLOCK_ALLOCATION is enabled, we don't want to have to
	 * malloc() space for nick,userhost,realname etc, so have it
	 * preallocated
	 */
	char	nick[NICKLEN + 1]; /* nickname */
	char	username[USERLEN + 1]; /* username */
	char	hostname[HOSTLEN + 1]; /* hostname */
	char	realname[REALLEN + 1]; /* realname */

#else

	char	*nick;
	char	*username;
	char	*hostname;
	char	*realname;

#endif /* BLOCK_ALLOCATION */

	int		umodes; /* global usermodes they have */
	Server		*server; /* pointer to server they're on */
	UserChan 	*firstchan; /* pointer to list of channels */
	time_t		since; /* when they connected to the network */

#ifdef NICKSERVICES

	time_t	nick_ts; /* time of their last nick change */
	time_t	nickreg_ts; /* time they last registered a nickname */

	#ifdef CHANNELSERVICES
		/* list of channels user has IDENTIFY'd for */
		struct f_chans
		{
			struct f_chans	*next;
			ChanInfo	*cptr;
		} *founder_channels;
	#endif

#endif /* NICKSERVICES */

	/*
	 * msgs_ts[0] is the timestamp of the first message they send services;
	 * msgs_ts[1] is the timestamp of the last message they send
	 */
	time_t	msgs_ts[2];
	int		messages; /* number of messages they've sent */
	int		flood_trigger; /* how many times they triggered flood protection */

	int		flags;

#ifdef STATSERVICES
	long	numops; /* how many times they +o'd someone */
	long	numdops; /* how many times they -o'd someone */
	long	numvoices; /* how many times they +v'd someone */
	long	numdvoices; /* how many times they -v'd someone */
	long	numnicks; /* how many times they've changed their nickname */
	long	numkicks; /* how many times they've kicked someone */
	long	numkills; /* how many times they've killed someone */
#endif /* STATSERVICES */

};
