/*
 * evars.h
 * Copyright (C) 1998-1999 Patrick Alken
 */

/*
 * This file contains various important external variables
 */

extern  char      hVersion[];

extern  MyInfo    Me;
extern  int       HubSock;
extern  int       errno;
extern  time_t    TimeStarted;
extern  long      gmt_offset;
extern  Luser     *ClientList;
extern  Servlist  *serverlist;
extern  aNetwork  *Network;
extern  Channel   *ChannelList;
extern  Server    *ServerList;
extern  DccUser   *connections;
extern  PortInfo  *portlist;

extern  rHost     *rhostlist;
extern  Userlist  *userlist;
extern  Chanlist  *mychanlist;
extern  Botlist   *botlist, *remotebots;
extern  Servlist  *currenthub;

extern  int       SafeConnect;
extern  int       HubCount;

extern  int       DccError;
extern  DccUser   *connections;

extern  Ignore    *ignorelist;

#ifdef ALLOW_JUPES
extern  Jupe      *jupelist;
#endif

#ifdef ALLOW_GLINES
extern  Gline     *glinelist;
#endif

#ifdef NICKSERVICES

extern  NickInfo  *nicklist[256];

#ifdef CHANNELSERVICES
extern  ChanInfo  *chanlist[256];
#endif

#ifdef MEMOSERVICES
extern  MemoInfo  *memolist[256];
#endif

#endif /* NICKSERVICES */

#if defined(CRYPT_PASSWORDS) || defined(CRYPT_OPER_PASSWORDS)
extern  char      *crypt();
#endif

#ifdef HIGHTRAFFIC_MODE
extern  int       HTM; /* high traffic mode */
extern  time_t    HTM_ts;
extern  int       ReceiveLoad;
#endif /* HIGHTRAFFIC_MODE */

extern  Userlist  *GenericOper;

#ifdef HAVE_PTHREADS
extern  int       GoodTimer;
#endif

extern  time_t    FloodTable[2];
extern  int       FloodHits;
extern  int       ActiveFlood;

/*
 * config.c variables
 */

extern  char      *HPath;
extern  char      *ConfigFile;
extern  char      *LogFile;
extern  char      *PidFile;
extern  char      *HelpPath;
extern  char      *MotdFile;
extern  char      *DccMotdFile;

extern  char      *GlineFile;
extern  char      *JupeFile;

extern  char      *NickServDB;
extern  char      *ChanServDB;
extern  char      *MemoServDB;
extern  char      *StatServDB;
extern  char      *OperServDB;

extern  char      *n_OperServ;
extern  char      *n_NickServ;
extern  char      *n_ChanServ;
extern  char      *n_MemoServ;
extern  char      *n_StatServ;
extern  char      *n_HelpServ;
extern  char      *id_OperServ;
extern  char      *id_NickServ;
extern  char      *id_ChanServ;
extern  char      *id_MemoServ;
extern  char      *id_StatServ;
extern  char      *id_HelpServ;
extern  char      *desc_OperServ;
extern  char      *desc_NickServ;
extern  char      *desc_ChanServ;
extern  char      *desc_MemoServ;
extern  char      *desc_StatServ;
extern  char      *desc_HelpServ;
extern  char      *ServiceUmodes;

extern  int       RestrictedAccess;
extern  int       AutoOpAdmins;
extern  int       OpersHaveAccess;
extern  int       SmartMasking;

extern  long      NickNameExpire;
extern  long      ChannelExpire;
extern  long      MemoExpire;
extern  long      StatExpire;
extern  long      NSReleaseTimeout;

extern  int       FloodProtection;
extern  int       FloodCount;
extern  long      FloodTime;
extern  long      IgnoreTime;
extern  int       IgnoreOffenses;

extern  int       MaxClones;
extern  char      *MaxClonesWarning;
extern  int       AutoKillClones;

extern  long      ConnectFrequency;
extern  long      ConnectBurst;
extern  int       ProxyCheck;
extern  int       MaxProxies;
extern  long      AutoLinkFreq;
extern  long      TelnetTimeout;
extern  long      IdentTimeout;
extern  long      BindAttemptFreq;
extern  int       MaxBinds;
extern  int       MaxConnections;
extern  int       OpersOnlyDcc;
extern  long      DatabaseSync;
extern  long      BackupFreq;
extern  int       ReloadDbsOnHup;
extern  int       NonStarChars;
extern  int       DefaultHubPort;
extern  int       DefaultTcmPort;
extern  int       LogLevel;
extern  int       MaxLogs;
extern  int       MaxModes;

extern  int       MaxTrace;
extern  int       MaxChannel;
extern  int       MaxKill;
extern  int       ServerNotices;

extern  int       NSSetKill;
extern  int       NSSetAutoMask;
extern  int       NSSetPrivate;
extern  int       NSSetSecure;
extern  int       NSSetUnSecure;
extern  int       NSSetAllowMemos;
extern  int       NSSetMemoSignon;
extern  int       NSSetMemoNotify;
extern  int       NSSetHide;
extern  int       NSSetHideEmail;
extern  int       NSSetHideUrl;
extern  int       NSSetHideQuit;
extern  int       LastSeenInfo;
extern  int       NicknameWarn;
extern  long      NickRegDelay;
extern  int       MaxLinks;
extern  int       AllowKillImmed;

extern  int       MaxChansPerUser;
extern  int       MaxAkicks;
extern  long      InhabitTimeout;
extern  int       AllowAccessIfSOp;
extern  int       RestrictRegister;
extern  int       GiveNotice;

extern  int       MaxMemos;
extern  long      MemoPurgeFreq;

extern  int       LagDetect;
extern  long      MaxPing;
