/*
 * headers.h
 * Copyright (C) 1998-1999 Patrick Alken
 */

/* Global/Common headers and extern declarations for HybServ */

#include "defs.h"

/* standard ANSI headers */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <assert.h>

/*
 * stdarg.h is generally more portable than varargs.h, try to
 * use it if possible for functions with variable arguments
 * like putlog()
 */
#include <stdarg.h>

/* standard POSIX headers */
#include	<sys/types.h>
#include	<unistd.h>
#include	<signal.h>
#include	<sys/errno.h>

/* Some systems have a broken time.h */
#if defined(TIME_WITH_SYS_TIME)
#  include <sys/time.h>
#  include <time.h>
#else
#  if defined(HAVE_SYS_TIME_H)
#    include <sys/time.h>
#  else
#    include <time.h>
#  endif /* HAVE_SYS_TIME_H */
#endif /* TIME_WITH_SYS_TIME */

#include	"config.h"
#include	"structs.h"
#include	"proto.h"

#if defined(HAVE_PTHREADS)
#  include <pthread.h>
#endif /* HAVE_PTHREADS */

#ifdef BLOCK_ALLOCATION

#include  "alloc.h"

extern  Heap   *ClientHeap;
extern  Heap   *ChannelHeap;
extern  Heap   *ServerHeap;

#endif /* BLOCK_ALLOCATION */

/* common includes */

#include  "channel.h"
#include  "client.h"
#include  "data.h"
#include  "dcc.h"
#include	"evars.h"
#include  "flood.h"
#include  "gline.h"
#include  "hash.h"
#include  "init.h"
#include  "jupe.h"
#include  "log.h"
#include  "match.h"
#include  "mystring.h"
#include  "show.h"
