/*
 * settings.h
 * Copyright (C) 1999 Patrick Alken
 *
 * $Id: settings.h,v 1.00 1999/08/19 08:14:46 wnder Exp $
 */

#define   PARAM_MAX         5 /* max parameters on one line */

typedef struct
{
	char *name; /* directive name */
	int flag; /* directive flag - D_* */

	struct
	{
		int type; /* type of variable "ptr" is - PARAM_* */
		void *ptr; /* where to store parameter */
	} param[PARAM_MAX];
} Directive;

extern  Directive  directives[];

/*
 * Prototypes
 */

Directive *FindDirective(char *);
int LoadSettings(int rehash);
int SaveSettings();

/* Parameter types */
#define   PARAM_STRING      1 /* parameter is a string */
#define   PARAM_INT         2 /* parameter is an integer */
#define   PARAM_TIME        3 /* parameter is in time format */
#define   PARAM_SET         4 /* parameter is configurable on/off */
#define   PARAM_PORT        5 /* parameter is a port number 1..65535 */

/* Directive types */
#define   D_REQUIRED        1 /* directive is required */
#define   D_OPTIONAL        2 /* directive is optional */
#define   D_NORUNTIME       3 /* directive is required and not run-time configurable */
