/*
 * structs.h
 * Copyright (C) 1998-1999 Patrick Alken
 */

#define 	YES	1
#define		NO	0
#define		NODCC		(-1)
#define		DCCALL	(-2)
#define		DCCOPS	(-3)

#define		NICKLEN   9   /* nickname length */
#define		REALLEN	  50  /* ircd value for max server info length */
#define		USERLEN   10  /* username length */
#define		HOSTLEN		63  /* hostname length */
#define		CHANNELLEN	200 /* channel length */
#define		KEYLEN    23  /* channel key length */
#define		SERVERLEN 63  /* server hostname length */

#define		UHOSTLEN	(USERLEN + HOSTLEN)

#define		CHARSIZE	sizeof(char)

/* number of bytes to read from sockets - used to be 8192 */
#define   BUFSIZE   16384

#define   MAXPARAM  15 /* max parameters the hub can send us */

#define   MAXLINE   512 /* don't change this */

/* Logging levels */

#define		LOG0		0  /* log nothing */
#define		LOG1		1  /* log security stuff - kills, admin commands etc */
#define		LOG2		2  /* same as 2, with some more events logged */
#define		LOG3		3  /* log all channel stuff as well */

#define		ERR_NOPRIVS	"No privileges"

/* NickServ error messages */
#define		ERR_NOT_YOUR_NICK	"This nickname is owned by someone else"
#define		ERR_NEED_IDENTIFY	"If this is your nickname, type /msg %s \002IDENTIFY\002 <password>"
#define		ERR_MUST_CHANGE		"If you do not \002IDENTIFY\002 within one minute, you will be disconnected"
#define		ERR_NOT_REGGED		"The nickname [\002%s\002] is not registered"
#define		ERR_MORE_INFO			"Type: \002/msg %s HELP %s\002 for more information"
#define		ERR_BAD_PASS			"Password Incorrect"
#define		ERR_NO_HELP				"No help available on \002%s %s\002"
#define   ERR_NOT_LINKED    "The nickname [\002%s\002] is not linked"

/* ChanServ error messages */
#define		ERR_CH_NOT_REGGED	"The channel [\002%s\002] is not registered"
#define		ERR_NEED_ACCESS		"An access level of [\002%d\002] is required for [\002%s\002] on %s"

/* socket flags */
#define		NOSOCKET			(-2)  /* unused socket in portlist */

#define		SOCK_UNUSED		0x01  /* unused socket */
#define		SOCK_TCMBOT		0x02  /* socket is a tcm bot connection */
#define		SOCK_BOTHUB		0x04  /* tcm bot is the hub */
#define		SOCK_PENDING	0x08  /* has the tcm sent the password yet? */
#define		SOCK_DCC			0x10  /* socket being used for dcc connection */
#define		SOCK_EOF			0x20  /* socket EOF'd during write() */
#define		SOCK_NEEDID		0x40  /* need ident reply */
#define 	SOCK_WRID			0x80  /* need to request ident */

/* channel flags */
#define	CH_VOICED				0x000001 /* user is voiced */
#define	CH_OPPED				0x000002 /* user is opped */
#define MODE_O					0x000004 /* someone was +o'd */
#define MODE_V					0x000008 /* someone was +v'd */
#define MODE_L					0x000010 /* channel is +l */
#define MODE_K					0x000020 /* channel is +k */
#define MODE_S					0x000040 /* channel is +s */
#define MODE_P					0x000080 /* channel is +p */
#define MODE_N					0x000100 /* channel is +n */
#define MODE_T					0x000200 /* channel is +t */
#define MODE_M					0x000400 /* channel is +m */
#define MODE_I					0x000800 /* channel is +i */

/* Luser flags */
#define	L_OSREGISTERED  0x0001 /* user is identified with OperServ */
#define L_PROXY         0x0002 /* user is running an insecure proxy */

/* OperServ usermodes */
#define OPERUMODE_INIT  0x00000001 /* umodes not initialized yet */
#define OPERUMODE_B     0x00000002 /* +b */
#define OPERUMODE_C			0x00000004 /* +c */
#define OPERUMODE_CAPC  0x00000008 /* +C */
#define OPERUMODE_E     0x00000010 /* +e */
#define OPERUMODE_CAPE  0x00000020 /* +E */
#define OPERUMODE_J     0x00000040 /* +j */
#define OPERUMODE_K     0x00000080 /* +k */
#define OPERUMODE_L     0x00000100 /* +l */
#define OPERUMODE_M     0x00000200 /* +m */
#define OPERUMODE_N     0x00000400 /* +n */
#define OPERUMODE_O     0x00000800 /* +o */
#define OPERUMODE_P     0x00001000 /* +p */
#define OPERUMODE_CAPO  0x00002000 /* +O */
#define OPERUMODE_S     0x00004000 /* +s */
#define OPERUMODE_CAPS  0x00008000 /* +S */
#define OPERUMODE_T     0x00010000 /* +t */
#define OPERUMODE_Y     0x00020000 /* +y */

/*
 * Debugging usermode (+d)
 */
#define OPERUMODE_D \
  (OPERUMODE_B | OPERUMODE_C | OPERUMODE_CAPC | OPERUMODE_E | \
   OPERUMODE_CAPE | OPERUMODE_J | OPERUMODE_K | OPERUMODE_L | \
   OPERUMODE_M | OPERUMODE_N | OPERUMODE_O | OPERUMODE_CAPO | \
   OPERUMODE_P | OPERUMODE_S | OPERUMODE_CAPS | OPERUMODE_T | \
   OPERUMODE_Y)

/* NickServ flags */
#define NS_IDENTIFIED		0x00000001 /* nick has IDENTIFY'd */
#define NS_PROTECTED		0x00000002 /* kill to regain nick */
#define NS_OPERATOR			0x00000004 /* owned by oper - doesn't expire */
#define NS_AUTOMASK			0x00000008 /* auto-add new hostmasks */
#define NS_PRIVATE			0x00000010 /* nick won't show up in a LIST */
#define NS_COLLIDE			0x00000020 /* stole a nick - kill them */
#define NS_RELEASE			0x00000040 /* to release an enforced nick */
#define NS_FORBID				0x00000080 /* nick is forbidden */
#define NS_SECURE				0x00000100 /* nick is secure */
#define NS_DELETE				0x00000200 /* delete after a RELOAD */
#define NS_UNSECURE			0x00000400 /* don't need to IDENTIFY */
#define NS_MEMOSIGNON   0x00000800 /* tell about memos on signon */
#define NS_MEMONOTIFY   0x00001000 /* tell about new memos */
#define NS_MEMOS        0x00002000 /* allow others to send memos */
#define NS_HIDEALL			0x00004000 /* hide email/url/quitmsg from INFO */
#define NS_HIDEEMAIL    0x00008000 /* hide email from INFO */
#define NS_HIDEURL      0x00010000 /* hide url from INFO */
#define NS_HIDEQUIT     0x00020000 /* hide quitmsg from INFO */
#define NS_HIDEADDR     0x00040000 /* hide last addy from INFO */
#define NS_KILLIMMED    0x00080000 /* kill immediately to regain nick */
#define NS_NOREGISTER   0x00100000 /* not allowed to register channels */
#define NS_NOCHANOPS    0x00200000 /* not allowed to be opped */

/* ChanServ flags */
#define CS_PRIVATE			0x00000001 /* channel won't show up in LIST */
#define CS_TOPICLOCK		0x00000002 /* must be changed via SET TOPIC */
#define CS_SECURE				0x00000004 /* channel is secure */
#define CS_SECUREOPS		0x00000008 /* only aop/sop/founders can be opped */
#define CS_SUSPENDED		0x00000010 /* channel is suspended */
#define CS_FORBID				0x00000020 /* channel is forbidden */
#define CS_RESTRICTED		0x00000040 /* channel is restricted */
#define CS_FORGET				0x00000080 /* channel is forgotten */
#define CS_DELETE				0x00000100 /* delete after a RELOAD */
#define CS_NOEXPIRE     0x00000200 /* never expires */
#define CS_GUARD        0x00000400 /* have ChanServ join the channel */

/* MemoServ flags */
#define MS_READ					0x00000001 /* memo has been read */
#define MS_DELETE				0x00000002 /* marked for deletion */
#define MS_RDELETE			0x00000004 /* delete after a RELOAD */

/* StatServ flags */
#define SS_DOMAIN				0x00000001 /* struct contains a domain, not host */

/* userlist privileges/flags */
#define PRIV_ADMIN			0x0001  /* can use administrator commands */
#define	PRIV_OPER				0x0002  /* can use operator commands */
#define PRIV_JUPE				0x0004  /* can use jupe/unjupe commands */
#define	PRIV_GLINE      0x0008  /* can use gline/ungline commands */
#define PRIV_CHAT				0x0010  /* can use dcc chat service */
#define PRIV_FRIEND			0x0020  /* has "friend" privileges */
#define PRIV_EXCEPTION	0x0040  /* protected user */
#define PRIV_SADMIN     0x0080  /* services administrator */

/* monitored channel flags */
#define CHAN_DELETE			0x001  /* to delete channels after a rehash */

/* server list flags */
#define SERV_DELETE     0x001  /* to delete servers after a rehash */

/* ServerInfo structure flags */
#define SERV_MYHUB      0x0001 /* services' current hub server */

/* User Mode flags */
#define UMODE_O					0x0001 /* IRC Operator */
#define UMODE_I					0x0002 /* Invisible */
#define UMODE_W					0x0004 /* Wallops */
#define UMODE_S					0x0008 /* Server Notices */

/* Network flags */
#define NET_OFF					0x0001 /* Services are deactivated */

/* Command execution levels */
#define LVL_NONE				0 /* anyone can execute */
#define LVL_IDENT				1 /* must be identified with NickServ */
#define LVL_OPER        2 /* must have "o" privs to execute */
#define LVL_ADMIN				3 /* must be an admin to execute */

/* access_lvl[] indices */
#define CA_AUTODEOP     0
#define CA_AUTOVOICE    1
#define CA_CMDVOICE     2
#define CA_ACCESS       3
#define CA_CMDINVITE    4
#define CA_AUTOOP       5
#define CA_CMDOP        6
#define CA_CMDUNBAN     7
#define CA_AKICK        8
#define CA_CMDCLEAR     9
#define CA_SET          10
#define CA_SUPEROP      11
#define CA_FOUNDER      12

#define CA_SIZE         13 /* number of indices */

/* Port flags */
#define PRT_TCM					1 /* accept only tcm bot connections */
#define PRT_USERS				2 /* accept only user connections */
#define PRT_DELETE			3 /* marked for deletion in a rehash */

/*
 * Forward declarations
 */
typedef struct LuserInfo Luser;
typedef struct ChannelInfo Channel;
typedef struct ServerInfo Server;
typedef struct ChanListInfo ChanInfo;
typedef struct u_chan UserChan;
typedef struct c_user ChanUser;
typedef struct JupeInfo Jupe;
typedef struct GlineInfo Gline;

/* OperServ Flag macros */

#define IsServicesAdmin(x) ((x) ? (x)->flags & PRIV_SADMIN : 0)
#define	IsAdmin(x)         ((x) ? (x)->flags & PRIV_ADMIN : 0)
#define	IsOper(x)          ((x) ? (x)->flags & PRIV_OPER : 0)
#define	IsProtected(x)     ((x) ? (x)->flags & PRIV_EXCEPTION : 0)
#define	IsFriend(x)        ((x) ? (x)->flags & PRIV_FRIEND : 0)
#define	CanJupe(x)         ((x) ? (x)->flags & PRIV_JUPE : 0)
#define	CanGline(x)        ((x) ? (x)->flags & PRIV_GLINE : 0)
#define	CanChat(x)         ((x) ? (x)->flags & PRIV_CHAT : 0)

#define ONEKIL	(1024.0)
#define ONEMEG	(1024.0 * 1024.0)
#define ONEGIG	(1024.0 * 1024.0 * 1024.0)
#define ONETER	(1024.0 * 1024.0 * 1024.0 * 1024.0)
#define GMKBs(x)	( ((x) > ONETER) ? "Terabytes" : (((x) > ONEGIG) ? "Gigabytes" : (((x) > ONEMEG) ? "Megabytes" : (((x) > ONEKIL) ? "Kilobytes" : "Bytes"))))
#define	GMKBv(x)	( ((x) > ONETER) ? (float)((x) / ONETER) : (((x) > ONEGIG) ? (float)((x) / ONEGIG) : (((x) > ONEMEG) ? (float)((x) / ONEMEG) : (((x) > ONEKIL) ? (float)((x) / ONEKIL) : (float)(x)))))

typedef struct MyInformation
{
	char *name; /* services' server name */
	char *info; /* services' info line */
	char *admin; /* administrative info */
	Server *sptr; /* pointer to services entry in server list */
	Server *hub; /* pointer to services' current hub server */
	
	Luser *osptr; /* pointer to OperServ client structure */

#ifdef NICKSERVICES

	Luser *nsptr; /* pointer to NickServ */

# ifdef CHANNELSERVICES
	Luser *csptr; /* pointer to ChanServ */
# endif /* CHANNELSERVICES */

# ifdef MEMOSERVICES
	Luser *msptr; /* pointer to MemoServ */
# endif /* MEMOSERVICES */

#endif /* NICKSERVICES */

#ifdef STATSERVICES
	Luser *ssptr; /* pointer to StatServ */
#endif /* STATSERVICES */

#ifdef HELPSERVICES
	Luser *hsptr; /* pointer to HelpServ */
#endif /* HELPSERVICES */
} MyInfo;

/* Stores server S: lines from hybserv.conf */
typedef struct ServListInfo 
{
	struct	ServListInfo	*next;
	char	*hostname; /* hostname of hub server */
	char	*password; /* password for connection */
	char	*realname; /* network name of hub (in case it doesn't match hostname) */
	int		port; /* port for connection */
	time_t	connect_ts; /* time we connected to it */
	long	flags;
} Servlist;

/* Stores O: lines from hybserv.conf */
typedef struct UserListInfo 
{
	struct UserListInfo *next;
	char *nick; /* nickname */
	char *username; /* username of user */
	char *hostname; /* hostname of user */
	char *password; /* password user must .identify with */
	int flags; /* privileges user has */
	long umodes; /* user modes set */

#ifdef RECORD_SPLIT_TS
	/*
	 * if they split, record their TS, so if they rejoin, we can
	 * check if their TS's match up and don't make them re-IDENTIFY
	 */
	time_t split_ts;
	time_t whensplit; /* for expiration purposes */
#endif
} Userlist;

/* Stores C: lines from hybserv.conf */
typedef struct MyChanList 
{
	struct	MyChanList	*next;
	char	*name; /* name of channel */
	int		flags; /* to mark CHAN_DELETE during rehash */
} Chanlist;

typedef struct BotListInfo
{
	struct BotListInfo	*next;
	char *name; /* nickname of tcm */
	char *username; /* username of tcm */
	char *hostname; /* hostname of tcm */
	char *password; /* password for tcm */
	int port; /* port for connection */
} Botlist;

/* Stores info for servers on network */
struct ServerInfo

{
	Server *next, *prev, *hnext;

#ifdef BLOCK_ALLOCATION
	char	name[SERVERLEN + 1]; /* name of server */
#else
	char	*name; /* name of server */
#endif

	long	numusers; /* number of users on server */
	long	numopers; /* number of operators on server */
	long	numoperkills; /* number of operator kills */
	long	numservkills; /* number of server kills */

	long	numservs; /* current servers linked */
	Server	*uplink; /* hub for this server */
	time_t	connect_ts; /* time server has been connected to its hub */

	long flags;

#ifdef STATSERVICES
	long	maxusers; /* max users seen on this server */
	time_t	maxusers_ts; /* when max users were seen */
	long	maxopers; /* max opers seen on this server */
	time_t	maxopers_ts; /* when max opers were seen */
	long	maxservs; /* max servers seen from this server */
	time_t	maxservs_ts; /* when max servs were seen */

	long	numidentd; /* number of identd clients on server */
	long	numreshosts; /* number of clients with resolving hosts */

	float maxping; /* maximum ping received from this server */
	time_t maxping_ts; /* when max ping was received */
	float minping; /* minimum ping received from this server */
	time_t minping_ts; /* when min ping was received */

	float ping; /* current ping time received from this server */
	long lastping_sec; /* TS of last time we pinged them */
	long lastping_usec; /* microseconds corresponding to lastping_sec */
#endif /* STATSERVICES */
};

typedef struct NetworkInfo
{
	float		TotalUsers; /* current user count */
	float		TotalServers; /* current server count */
	float		TotalOperators; /* current operator count */
	float		TotalChannels; /* current channel count */
	float		TotalOperKills; /* operator kills seen since startup */
	float		TotalServKills; /* server kills seen since startup */
	int			TotalJupes; /* number of jupes */
	int			TotalGlines; /* number of glines */
	int			TotalConns; /* number of dcc connections */
	int			MyChans; /* number of monitored channels */
	int			flags;

	long		RecvB; /* total bytes received */
	/*
	 * total bytes received 10 seconds ago - so we can check if
	 * we should enter high-traffic mode
	 */
	long		CheckRecvB;
	/*
	 * This is set to the current RecvB, so 10 seconds from now
	 * we can set CheckRecvB to LastRecvB, and update LastRecvB
	 * to the current RecvB again
	 */
	long		LastRecvB;

	long		SendB; /* total bytes sent */
	Server	*firstserv; /* ptr to first server in list */

#ifdef NICKSERVICES
	int			TotalNicks; /* number of registered nicknames */

#ifdef CHANNELSERVICES
	int			TotalChans; /* number of registered channels */
#endif

#ifdef MEMOSERVICES
	int			TotalMemos; /* number of memos */
#endif

#endif /* NICKSERVICES */

#ifdef STATSERVICES
	long		MaxUsers; /* max users seen */
	time_t	MaxUsers_ts;
	long		MaxServers; /* max servers seen */
	time_t	MaxServers_ts;
	long		MaxOperators; /* max operators seen */
	time_t	MaxOperators_ts;
	long		MaxChannels; /* max channels seen */
	time_t	MaxChannels_ts;

	long		Identd; /* number of clients running identd */
	long		NonIdentd; /* number of clients not running identd */
	long		ResHosts; /* number of clients with resolving hosts */

	long		MaxUsersT; /* max users seen today */
	time_t	MaxUsersT_ts;
	long		MaxServersT; /* max servers seen today */
	time_t	MaxServersT_ts;
	long		MaxOperatorsT; /* max operators seen today */
	time_t	MaxOperatorsT_ts;
	long		MaxChannelsT; /* max channels seen today */
	time_t	MaxChannelsT_ts;
	long		OperKillsT; /* oper kills seen today */
	long		ServKillsT; /* server kills seen today */
#endif /* STATSERVICES */
} aNetwork;

/* info for dcc/tcm connections */
typedef struct DccInfo
{
	struct DccInfo	*next, *prev;
	int socket; /* socket file descriptor */
	int authfd; /* ident file descriptor */
	int port; /* remote port */
	char *nick; /* nickname */
	char *username; /* username */
	char *hostname; /* hostname */
	int flags; /* socket flags */

	/*
	 * time of their last message - for telnet clients who haven't
	 * entered their password yet, time that they connected
	 */
	time_t idle;
} DccUser;

typedef struct ignore_
{
	struct ignore_ *next;
	time_t	expire; /* 0 if permanent ignore */
	char	*hostmask; /* hostmask to ignore */
} Ignore;

#ifdef NICKSERVICES

typedef struct nickhost_
{
	struct nickhost_ *next;
	char 	*hostmask; /* hostmask for nickname */
} NickHost;

/* structure for registered nicknames */
typedef struct NickListInfo
{
	struct NickListInfo	*next;
	char	*nick; /* registered nickname */
	char	*password; /* password */
	NickHost	*hosts; /* recognized hosts for this nick */
	time_t	created; /* timestamp when it was registered */
	time_t	lastseen; /* for expiration purposes */
	long		flags; /* nick flags */

	char		*email; /* email address */
	char		*url; /* url */

	char		*lastu; /* last seen username */
	char		*lasth; /* last seen hostname */
	char		*lastqmsg; /* last quit message */

	time_t	collide_ts; /* TS of when to collide them */

#ifdef RECORD_SPLIT_TS
	/*
	 * if they split, record their TS, so if they rejoin, we can
	 * check if their TS's match up and don't make them re-IDENTIFY
	 */
	time_t	split_ts;
	time_t	whensplit; /* for expiration purposes */
#endif /* RECORD_SPLIT_TS */

#ifdef LINKED_NICKNAMES
	/*
	 * Pointer to next nick in the nickname link list
	 */
	struct NickListInfo *nextlink;

	/*
	 * If this is the "hub" nickname for a list of linked nicknames,
	 * master will be NULL. If this nickname is a leaf, master will
	 * point to the "hub" nickname of this list
	 */
	struct NickListInfo *master;

	/*
	 * Number of links in the list this nickname is a part of.
	 * This is only non-zero if this nickname is a master
	 */
	int numlinks;
#endif /* LINKED_NICKNAMES */

#ifdef CHANNELSERVICES
	int numchans; /* number of channels registered to this nickname */
#endif /* CHANNELSERVICES */

} NickInfo;

#ifdef CHANNELSERVICES

typedef struct ChanAccessInfo
{
	struct	ChanAccessInfo	*next;
	char		*hostmask; /* hostmask that has access */
	NickInfo	*nptr; /* nickname */
	short		level; /* privs mask has */
} ChanAccess;

typedef struct AutoKickInfo
{
	struct	AutoKickInfo	*next;
	char	*hostmask; /* mask to autokick */
	char	*reason; /* reason for autokick */
} AutoKick;

struct ChanListInfo
{
	struct ChanListInfo	*next;
	char		*name;
	char		*founder; /* nickname of founder (must be registered) */
	char		*successor; /* nickname of successor (must be registered) */
	char		*password; /* founder password */
	char		*topic; /* NULL if no topic lock */
	long		limit; /* 0 if no limit */
	char		*key; /* NULL if no key */
	int			modes_on, /* modes to enforce */
					modes_off; /* modes to enforce off */
	ChanAccess	*access; /* access list */
	int		akickcnt; /* number of akicks */
	AutoKick	*akick; /* autokick list */

	char		*entrymsg; /* msg to send to users upon entry to channel */
	char		*email; /* email address of channel */
	char		*url; /* url of channel */

	struct	f_users
	{
		struct f_users	*next;
		Luser		*lptr;
	} *founders; /* list of users who have founder access */

	time_t	created; /* timestamp when it was registered */
	time_t	lastused; /* for expiration purposes */
	short		*access_lvl; /* customized access levels for this channel */
	long		flags; /* channel flags */
};

#endif /* CHANNELSERVICES */

#ifdef MEMOSERVICES

typedef struct memo_
{
	struct memo_	*next;
	char	*sender;
	long	index; /* index number */
	time_t	sent; /* time it was sent */
	char	*text;
	long	flags;
} Memo;

typedef struct MemoListInfo
{
	struct MemoListInfo	*next, *prev;
	char	*name; /* who the memo was sent to */
	long	memocnt; /* number of memos */
	long	newmemos; /* number of unread memos */
	Memo	*memos; /* the actual memos */
	Memo	*lastmemo; /* ptr to last memo in list */
	long	flags;
} MemoInfo;

#endif /* MEMOSERVICES */

#endif /* NICKSERVICES */

typedef struct servcommands {
	char *cmd; /* holds command */
	void (* func)(); /* function to call */
} ServCmd;

typedef struct o_commands {
	char *cmd; /* holds command */
	void (* func)(); /* function to call depending on 'cmd' */
	int dcconly; /* dcc chat command only? 1 if yes, 0 if not */
	char flag; /* flag needed to use the command */
} o_Command;

typedef struct commands {
	char	*cmd; /* holds command */
	void	(* func)(); /* corresponding function */
	/*
	 * LVL_NONE if anyone can execute it
	 * LVL_IDENT if nick needs to have IDENTIFY'd before using 'cmd'
	 * LVL_ADMIN if nick needs to match an admin line
	 */
	int		level;
} Command;

/* info for sub processes */
typedef struct processes {
	int		index; /* index in array */
	pid_t		pid; /* process-id */
	char	*who; /* who started it */
	char	*target; /* for use with o_fuckover() */
} Process;

/* Stores I: line info from hybserv.conf */
typedef struct rHosts {
	struct rHosts *next;
	char *username; /* username of restricted hostmask */
	char *hostname; /* hostname of restricted hostmask */
	int hostnum; /* number of connections allowed from hostmask */
} rHost;

/* Stores P: line info from hybserv.conf */
typedef struct PortListInfo
{
	struct	PortListInfo	*next;
	int			port; /* port to listen on */
	char		*host; /* hostmask to allow */
	int			socket; /* socket file descriptor */
	int			type; /* type of connections to accept */
	int			tries; /* how many times we've tried to bind the port */
} PortInfo;

#ifdef STATSERVICES

/* Stores info for clients' hostnames */
typedef struct HostHashInfo
{
	struct	HostHashInfo	*hnext;
	char	*hostname;

	time_t	lastseen; /* last time someone had this host */
	long	currclients; /* current clients from this host */
	long	curropers; /* current opers from this host */
	long	currunique; /* current unique clients from this host */
	long	curridentd; /* current clients running identd */

	long	maxclients; /* max clients seen from this host */
	time_t	maxclients_ts; /* time max clients were seen */
	long	maxunique; /* max unique (not cloned) clients from this host */
	time_t	maxunique_ts; /* time unique clients were seen */
	long	maxopers; /* max opers seen from this host */
	time_t	maxopers_ts; /* time max opers were seen */

	int		flags; /* is it a hostname or domain? */
} HostHash;

#endif /* STATSERVICES */
